import { Component, Input, OnInit } from '@angular/core';
import { environment } from 'environments/environment';
import { TaskInstance } from '../../models/task-instance';

@Component({
  selector: 'ngx-eclipse-import',
  templateUrl: './eclipse-import.component.html',
  styleUrls: ['./eclipse-import.component.scss']
})
export class EclipseImportComponent implements OnInit {
  @Input() taskInstance: TaskInstance | null;

  pluginDocsIndexUrl = `${environment.manualUrl}/eclipse-plugin`;
  pluginDocsManualImportUrl = `${environment.manualUrl}/eclipse-plugin/import`;
  importLink: string | null;

  constructor() { }

  ngOnInit(): void {
    if(this.taskInstance != null) {
      this.generateImportLink();
    }
  }

  generateImportLink() {
    this.importLink = `eclipse+command://de.hsrm.sls.subato.eclipse.core.commands.importTask?de.hsrm.sls.subato.eclipse.core.commands.importTask.parameter.exerciseId=${this.taskInstance.exercise.id}&de.hsrm.sls.subato.eclipse.core.commands.importTask.parameter.taskId=${this.taskInstance.task.id}`;
  }
}
