import { Exercise } from "app/features/exercises/models/exercise";
import { Submission } from "app/features/exercises/models/submission";
import { Solution } from "app/features/solutions/models/solution";
import { TaskInstance } from "./task-instance";

export class ExerciseProgress {
    exercise: Exercise;
    taskInstances: TaskInstance[];
    testsPassed: number;
    testsTotal: number;
    styleErrorsTotal: number;
    leaksTotal: number;
    submission: Submission;
    solutions: Solution[];

    constructor(exerciseProgress: any) {
        this.testsPassed = exerciseProgress.testsPassed;
        this.testsTotal = exerciseProgress.testsTotal;
        this.styleErrorsTotal = exerciseProgress.styleErrorsTotal;
        this.leaksTotal = exerciseProgress.leaksTotal;
        this.exercise = new Exercise(exerciseProgress.exercise);
        this.taskInstances = exerciseProgress.taskInstances.map(ti => new TaskInstance(ti));
        this.submission = exerciseProgress.submission ? new Submission(exerciseProgress.submission) : null;
        this.solutions = exerciseProgress.solutions.map(r => new Solution(r));
    }
}