
import { Course } from 'app/features/courses/models/course';
import { Iso8601Helper } from 'app/shared/helper/iso8601.helper';
import * as moment from 'moment';
import { TaskInstance } from './task-instance';

export class Exercise {
    id: number;
    name: string;
    description: string;
    summary: string;
    usingPoints: boolean;
    course: Course;
    dueTo: moment.Moment;
    visibleFrom: moment.Moment;
    reachablePoints: number;
    visible: boolean;

    constructor(exercise: any) {
        this.id = exercise.id;
        this.name = exercise.name;
        this.description = exercise.description;
        this.summary = exercise.summary;
        this.usingPoints = exercise.usingPoints;
        this.reachablePoints = exercise.reachablePoints;
        this.course = exercise.course ? new Course(exercise.course) : null;
        this.dueTo = Iso8601Helper.fromString(exercise.dueTo);
        this.visibleFrom = Iso8601Helper.fromString( exercise.visibleFrom);
        this.visible = exercise.visible;
    }

    isActive(): boolean {
        return this.dueTo ? moment().isSameOrBefore(this.dueTo) : true;
    }
}

