import { Submission } from "./submission";

export class SubmissionsProgress {
    passedTotal: number;
    notPassedTotal: number;
    undecidedTotal: number;

    constructor(dto: any) {
        this.passedTotal = dto.passedTotal;
        this.notPassedTotal = dto.notPassedTotal;
        this.undecidedTotal = dto.undecidedTotal;
    }

    update(submissions: Submission[]): SubmissionsProgress {
        return new SubmissionsProgress({
            passedTotal: submissions.filter(s => s.passed == true).length,
            notPassedTotal: submissions.filter(s => s.passed == false).length,
            undecidedTotal: submissions.filter(s => s.passed == null).length
        });
    }

    get progress() {
        return this.total != 0 ? this.decided / this.total * 100 : 100;
    }

    get total() {
        return this.notPassedTotal + this.passedTotal + this.undecidedTotal;
    }

    get decided() {
        return this.total - this.undecidedTotal;
    }
}