import { NgModule } from '@angular/core';
import { Routes, RouterModule, ActivatedRouteSnapshot } from '@angular/router';
import { EditTermComponent } from './pages/edit-term/edit-term.component';
import { NewTermComponent } from './pages/new-term/new-term.component';
import { TermsComponent } from './pages/terms/terms.component';

export const routes: Routes = [
  {
    path: 'term',
    component: TermsComponent,
    data: {
      authRequired: true
    }
  },
  {
    path: 'term/new',
    component: NewTermComponent,
    data: {
      authRequired: true
    }
  },
  {
    path: 'term/:term_id/edit',
    component: EditTermComponent,
    data: {
      authRequired: true
    }
  },
];

@NgModule({
  exports: [RouterModule]
})
export class ModulesRoutingModule { }
