import { User } from "app/core/models/user";
import { Iso8601Helper } from "app/shared/helper/iso8601.helper";
import * as moment from 'moment';

export class TaskFeedback {
    id: number;
    comment: string;
    from: User;
    submittedAt: moment.Moment;
    complexity: number;
    comprehensibility: number;
    read: boolean;

    constructor(feedback: any) {
        this.id = feedback.id;
        this.comment = feedback.comment;
        this.from = new User(feedback.from);
        this.submittedAt = Iso8601Helper.fromString(feedback.submittedAt);
        this.complexity = feedback.complexity;
        this.comprehensibility = feedback.comprehensibility;
        this.read = feedback.read;
    }
}