import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { SubatoPrincipal } from 'app/core/models/principal/subato-principal';
import { AuthService } from 'app/core/services/auth.service';
import { BaseComponent } from 'app/shared/components/base/base.component';
import { combineLatest } from 'rxjs';
import { takeUntil } from 'rxjs/operators';
import { Language } from '../../models/language';

@Component({
  selector: 'ngx-languages',
  templateUrl: './languages.component.html',
  styleUrls: ['./languages.component.scss']
})
export class LanguagesComponent extends BaseComponent implements OnInit {
  loading: boolean;
  principal: SubatoPrincipal;
  deletingLanguage: Language | null;
  
  constructor(
    private authService: AuthService,
    private route: ActivatedRoute) {
    super();
  }

  ngOnInit(): void {
    this.loading = true;
    combineLatest(this.route.paramMap, this.authService.principal$)
      .pipe(
        takeUntil(this.unsubscribe),
      )
      .subscribe(([params, principal]) => {
        this.principal = principal;
        this.loading = false;
      });
  }
}
