import { Component, Input, OnInit } from '@angular/core';
import { BackendError } from 'app/shared/models/backend-error';
import { ErrorConfig } from '../error-alert/error-alert.component';

export interface ErrorContainerConfig {
  [errorType: string]: ErrorConfig;
}

@Component({
  selector: 'ngx-error-container',
  templateUrl: './error-container.component.html',
  styleUrls: ['./error-container.component.scss']
})
export class ErrorContainerComponent implements OnInit {
  @Input() error: BackendError | null;
  @Input() config: ErrorContainerConfig | null;

  constructor() { }

  ngOnInit(): void {
  }

  notFoundConfig(): ErrorConfig {
    let defaultConfig: ErrorConfig = {
      title: 'Hier ist nichts.',
      message: 'Diesen Eintrag konnten wir leider nicht finden.',
      ...(this.config?.['notFound'] ?? {})
    };

    return defaultConfig;
  }

  internalConfig(): ErrorConfig {
    let defaultConfig: ErrorConfig = {
      title: 'Hoppla.',
      message: 'Irgendetwas hat nicht geklappt, bitte versuche es erneut und wende dich an uns, wenn das Problem weiter besteht.',
      ...(this.config?.['internal'] ?? {})
    };

    return defaultConfig;
  }

  accessDeniedConfig(): ErrorConfig {
    let defaultConfig: ErrorConfig = {
      title: 'You Shall Not Pass.',
      message: 'Darauf darfst du nicht zugreifen. Wende dich an uns, wenn du denkst, dass das ein Fehler ist.',
      ...(this.config?.['accessDenied'] ?? {})
    };

    return defaultConfig;
  }
}
