package de.hsrm.sls.subato.auth.policy.attendance;

import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.courses.event.CourseUnitEvent;
import de.hsrm.sls.subato.courses.membership.StaffGroup;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to update attendance within a course
 */
@Component
public class AttendanceUpdatePolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(AttendancePermission.ATTENDANCE_UPDATE) || request.unauthenticated()) {
            return false;
        }

        var event = (CourseUnitEvent) request.getObj();
        return request.getSubject().hasGroup(event.getUnit().getCourse().getId(), StaffGroup.LECTURER);
    }
}
