package de.hsrm.sls.subato.auth.policy.courses;

import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.courses.membership.StaffGroup;
import de.hsrm.sls.subato.courses.unit.CourseUnit;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to update a course unit within a certain course
 */
@Component
public class CourseUnitUpdatePolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(CoursesAction.COURSE_UNIT_UPDATE) || request.unauthenticated()) {
            return false;
        }

        var unit = (CourseUnit) request.getObj();
        return request.getSubject().hasGroup(unit.getCourse().getId(), StaffGroup.ADMIN) || request.getSubject().hasGroup(unit.getCourse().getId(), StaffGroup.LECTURER);
    }
}
