package de.hsrm.sls.subato.auth.policy.solutions;

import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.auth.policy.exercises.ExercisesAction;
import de.hsrm.sls.subato.solutions.comment.SolutionComment;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to delete a comment for a certain solution
 */
@Component
public class SolutionCommentDeletePolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(SolutionsAction.SOLUTION_COMMENT_DELETE) || request.unauthenticated()) {
            return false;
        }

        var comment = (SolutionComment) request.getObj();
        return comment.getFrom().getId() == request.getSubject().getId();
    }
}
