package de.hsrm.sls.subato.auth.policy.solutions;

import de.hsrm.sls.subato.auth.Role;
import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.auth.policy.exercises.ExercisesAction;
import de.hsrm.sls.subato.courses.membership.StaffGroup;
import de.hsrm.sls.subato.solutions.solution.Solution;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to run acceptance tests for a solution within a certain course
 */
@Component
public class SolutionRunAcceptanceTestsPolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(SolutionsAction.SOLUTION_RUN_ACCEPTANCE_TESTS) || request.unauthenticated()) {
            return false;
        }

        var solution = (Solution) request.getObj();
        return solution.getExercise() != null
                ? request.getSubject().hasGroup(solution.getExercise().getCourse().getId(), StaffGroup.LECTURER)
                : request.getSubject().hasRole(Role.Staff);
    }
}
