package de.hsrm.sls.subato.seed;

import de.hsrm.sls.subato.aor.term.TermDataImportManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;

@Service
@Transactional
public class TermDataSeedService {
    @Autowired
    private TermDataImportManager termDataImportManager;

    public void seedTermData(File seedDir) {
        try {
            var coreDataDir = seedDir.toPath().resolve("term-data").toFile();
            if(coreDataDir.exists()) {
                for(var file : coreDataDir.listFiles()) {
                    var json = Files.readString(file.toPath(), StandardCharsets.UTF_8);
                    termDataImportManager.importFromJson(json);
                }
            }
        } catch (IOException e) {
            throw new SeedingException(e);
        }
    }
}
