package de.hsrm.sls.subato.solutions.evaluation.result;

import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.persistence.*;

/**
 * the fields here refer to the output of https://checkstyle.sourceforge.io/
 */
@Entity
@Table(name = "style_check_result")
public class StyleCheckResult {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    private String file;
    @Column(length = 1000000)
    private String message;
    private String severity;
    private String line;
    private String col;

    @JsonIgnore
    @ManyToOne
    private EvalResult evalResult;

    public long getId() {
        return id;
    }

    public String getFile() {
        return file;
    }

    public String getMessage() {
        return message;
    }

    public String getSeverity() {
        return severity;
    }

    public String getLine() {
        return line;
    }

    public String getCol() {
        return col;
    }

    public void setId(long id) {
        this.id = id;
    }

    public void setFile(String file) {
        this.file = file;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public void setSeverity(String severity) {
        this.severity = severity;
    }

    public void setLine(String line) {
        this.line = line;
    }

    public void setCol(String column) {
        this.col = column;
    }

    public EvalResult getEvalResult() {
        return evalResult;
    }

    public void setEvalResult(EvalResult evalResult) {
        this.evalResult = evalResult;
    }
}
