package de.hsrm.sls.subato.tasks.stef.parser.meta;

import de.hsrm.sls.subato.shared.mime.MimeMapping;
import de.hsrm.sls.subato.tasks.stef.Meta;
import de.hsrm.sls.subato.tasks.stef.parser.InvalidSpecException;
import de.hsrm.sls.subato.tasks.stef.parser.meta.xml.*;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

@Service
public class MimeMappingsExtractor {
    public void extract(TaskXml doc, Meta meta) {
        var mimeMappings = new ArrayList<MimeMapping>();

        if(doc.getMimeMappings() != null) {
            for (var mapping : doc.getMimeMappings().getMappings()) {
                if(mapping.getMap() == null) {
                    throw new InvalidSpecException("%s-Attribut in %s fehlt".formatted(MimeMappingXml.MAP, MimeMappingsXml.MIME_MAPPING));
                }

                if(mapping.getAs() == null) {
                    throw new InvalidSpecException("%s-Attribut in %s fehlt".formatted(MimeMappingXml.AS, MimeMappingsXml.MIME_MAPPING));
                }

                mimeMappings.add(new MimeMapping(mapping.getMap(), mapping.getAs()));
            }
        }

        meta.setMimeMappings(mimeMappings);
    }
}
