package de.hsrm.sls.subato.tasks.task;

import de.hsrm.sls.subato.tasks.pool.TaskPool_;
import org.springframework.data.jpa.domain.Specification;

import java.util.Optional;

import static de.hsrm.sls.subato.shared.QueryPredicates.ignoreCaseContains;

public class TaskSpecifications {
    public static Specification<Task> archived(boolean archived) {
        return (ex, cq, cb) -> cb.equal(ex.get(Task_.archived), archived);
    }

    public static Specification<Task> applyQuery(String q) {
        return (ex, cq, cb) -> cb.or(
                ignoreCaseContains(cb, Optional.of(q), ex.get(Task_.name)),
                ignoreCaseContains(cb, Optional.of(q), ex.get(Task_.idName)),
                ignoreCaseContains(cb, Optional.of(q), ex.get(Task_.description))
        );
    }

    public static Specification<Task> poolEquals(Long poolId) {
        return (ex, cq, cb) -> cb.equal(ex.get(Task_.pool).get(TaskPool_.id), poolId);
    }
}
